;;;
;;; $Header: /home/gene/icfp2001/source/RCS/action.lisp,v 1.3 2001/07/29 05:22:10 gene Exp $
;;;

(defconstant *all-actions* '(pop push))

(defun action-ensure (action attrchars)
  "Returns a (possibly newly allocated) list of actions that has at least as
many elements as does attrchars.  Attrchars is a list of attributed
characters."

  (when (< (length action) (length attrchars))
    (format t "~&action-ensure: warning: actions are shorter than ")
    (format t "attrchars."))
  action

  ;; Here's the original implementation.
  ;; It was slowing things down & causing stack overflows on large
  ;; inputs, so I've commented it out.  Currently, we ensure that 
  ;; the list of actions is large enough elsewhere.  If we ever
  ;; need to massage a list of actions to be large enough, we
  ;; can re-implement this in a non-recursive way.
  ;; (cond ((endp attrchars) action)
  ;; ((endp action)
  ;; (cons (random-elt *all-actions*)
  ;; (action-ensure nil (cdr attrchars))))
  ;; (t (cons (car action) (action-ensure (cdr action) (cdr attrchars)))))
  )

;;; --- end of file ---
